 // ============================================================================
// Copyright (c) 2013 by Terasic Technologies Inc.
// ============================================================================
//
// Permission:
//
//   Terasic grants permission to use and modify this code for use
//   in synthesis for all Terasic Development Boards and Altera Development 
//   Kits made by Terasic.  Other use of this code, including the selling 
//   ,duplication, or modification of any portion is strictly prohibited.
//
// Disclaimer:
//
//   This VHDL/Verilog or C/C++ source code is intended as a design reference
//   which illustrates how these types of functions can be implemented.
//   It is the user's responsibility to verify their design for
//   consistency and functionality through the use of formal
//   verification methods.  Terasic provides no warranty regarding the use 
//   or functionality of this code.
//
// ============================================================================
//           
//  Terasic Technologies Inc
//  9F., No.176, Sec.2, Gongdao 5th Rd, East Dist, Hsinchu City, 30070. Taiwan
//  
//  
//                     web: http://www.terasic.com/  
//                     email: support@terasic.com
//
// ============================================================================
//Date:  Mon Jun 17 20:35:29 2013
// ============================================================================

//`define ENABLE_HPS

module DE1_SoC_TV(

      ///////// ADC /////////
      output             ADC_CONVST,
      output             ADC_DIN,
      input              ADC_DOUT,
      output             ADC_SCLK,

      ///////// AUD /////////
      input              AUD_ADCDAT,
      inout              AUD_ADCLRCK,
      inout              AUD_BCLK,
      output             AUD_DACDAT,
      inout              AUD_DACLRCK,
      output             AUD_XCK,

      ///////// CLOCK2 /////////
      input              CLOCK2_50,

      ///////// CLOCK3 /////////
      input              CLOCK3_50,

      ///////// CLOCK4 /////////
      input              CLOCK4_50,

      ///////// CLOCK /////////
      input              CLOCK_50,

      ///////// DRAM /////////
      output      [12:0] DRAM_ADDR,
      output      [1:0]  DRAM_BA,
      output             DRAM_CAS_N,
      output             DRAM_CKE,
      output             DRAM_CLK,
      output             DRAM_CS_N,
      inout       [15:0] DRAM_DQ,
      output             DRAM_LDQM,
      output             DRAM_RAS_N,
      output             DRAM_UDQM,
      output             DRAM_WE_N,

      ///////// FAN /////////
      output             FAN_CTRL,

      ///////// FPGA /////////
      output             FPGA_I2C_SCLK,
      inout              FPGA_I2C_SDAT,

      ///////// GPIO /////////
      inout     [35:0]         GPIO_0,
      inout     [35:0]         GPIO_1,
 

      ///////// HEX0 /////////
      output      [6:0]  HEX0,

      ///////// HEX1 /////////
      output      [6:0]  HEX1,

      ///////// HEX2 /////////
      output      [6:0]  HEX2,

      ///////// HEX3 /////////
      output      [6:0]  HEX3,

      ///////// HEX4 /////////
      output      [6:0]  HEX4,

      ///////// HEX5 /////////
      output      [6:0]  HEX5,

`ifdef ENABLE_HPS
      ///////// HPS /////////
      inout              HPS_CONV_USB_N,
      output      [14:0] HPS_DDR3_ADDR,
      output      [2:0]  HPS_DDR3_BA,
      output             HPS_DDR3_CAS_N,
      output             HPS_DDR3_CKE,
      output             HPS_DDR3_CK_N,
      output             HPS_DDR3_CK_P,
      output             HPS_DDR3_CS_N,
      output      [3:0]  HPS_DDR3_DM,
      inout       [31:0] HPS_DDR3_DQ,
      inout       [3:0]  HPS_DDR3_DQS_N,
      inout       [3:0]  HPS_DDR3_DQS_P,
      output             HPS_DDR3_ODT,
      output             HPS_DDR3_RAS_N,
      output             HPS_DDR3_RESET_N,
      input              HPS_DDR3_RZQ,
      output             HPS_DDR3_WE_N,
      output             HPS_ENET_GTX_CLK,
      inout              HPS_ENET_INT_N,
      output             HPS_ENET_MDC,
      inout              HPS_ENET_MDIO,
      input              HPS_ENET_RX_CLK,
      input       [3:0]  HPS_ENET_RX_DATA,
      input              HPS_ENET_RX_DV,
      output      [3:0]  HPS_ENET_TX_DATA,
      output             HPS_ENET_TX_EN,
      inout       [3:0]  HPS_FLASH_DATA,
      output             HPS_FLASH_DCLK,
      output             HPS_FLASH_NCSO,
      inout              HPS_GSENSOR_INT,
      inout              HPS_I2C1_SCLK,
      inout              HPS_I2C1_SDAT,
      inout              HPS_I2C2_SCLK,
      inout              HPS_I2C2_SDAT,
      inout              HPS_I2C_CONTROL,
      inout              HPS_KEY,
      inout              HPS_LED,
      inout              HPS_LTC_GPIO,
      output             HPS_SD_CLK,
      inout              HPS_SD_CMD,
      inout       [3:0]  HPS_SD_DATA,
      output             HPS_SPIM_CLK,
      input              HPS_SPIM_MISO,
      output             HPS_SPIM_MOSI,
      inout              HPS_SPIM_SS,
      input              HPS_UART_RX,
      output             HPS_UART_TX,
      input              HPS_USB_CLKOUT,
      inout       [7:0]  HPS_USB_DATA,
      input              HPS_USB_DIR,
      input              HPS_USB_NXT,
      output             HPS_USB_STP,
`endif /*ENABLE_HPS*/

      ///////// IRDA /////////
      input              IRDA_RXD,
      output             IRDA_TXD,

      ///////// KEY /////////
      input       [3:0]  KEY,

      ///////// LEDR /////////
      output      [9:0]  LEDR,

      ///////// PS2 /////////
      inout              PS2_CLK,
      inout              PS2_CLK2,
      inout              PS2_DAT,
      inout              PS2_DAT2,

      ///////// SW /////////
      input       [9:0]  SW,

      ///////// TD /////////
      input              TD_CLK27,
      input      [7:0]  TD_DATA,
      input             TD_HS,
      output             TD_RESET_N,
      input             TD_VS,

      ///////// VGA /////////
      output      [7:0]  VGA_B,
      output             VGA_BLANK_N,
      output             VGA_CLK,
      output      [7:0]  VGA_G,
      output             VGA_HS,
      output      [7:0]  VGA_R,
      output             VGA_SYNC_N,
      output             VGA_VS
);


wire [8:0] LED_GREEN;
wire [17:0] LED_RED;

//=======================================================
//  REG/WIRE declarations
//=======================================================
reg R_W;
reg [17:0] addr_reg;
reg [15:0] data_reg; //memory data register  for SRAM
reg we ;		//write enable for SRAM
wire [15:0] SRAM_DQ;	

sram_full sram_mod(
	.address_full(addr_reg),
	.clock_full  (CLOCK_50),
	.data_full   (data_reg),
	.wren_full   (~we),
	.q_full      (SRAM_DQ)
//	.reset       (!KEY[3])
	);

	
// SRAM_control		
//output enable is overidden by WE
	
wire	CLK_18_4;
wire	CLK_25;

//	For Audio CODEC
wire		AUD_CTRL_CLK;	//	For Audio Controller

//	For ITU-R 656 Decoder
wire	[15:0]	YCbCr;
wire	[9:0]	TV_X;
wire			TV_DVAL;

//	For VGA Controller
wire	[9:0]	mRed;
wire	[9:0]	mGreen;
wire	[9:0]	mBlue;
wire	[10:0]	VGA_X;
wire	[10:0]	VGA_Y;
wire			VGA_Read;	//	VGA data request
wire			m1VGA_Read;	//	Read odd field
wire			m2VGA_Read;	//	Read even field

//	For YUV 4:2:2 to YUV 4:4:4

//	For field select
wire	[15:0]	mYCbCr;
wire	[15:0]	mYCbCr_d;
wire	[15:0]	m1YCbCr;
wire	[15:0]	m2YCbCr;
wire	[15:0]	m3YCbCr;

//	For Delay Timer
wire			TD_Stable;
wire			DLY0;
wire			DLY1;
wire			DLY2;

//	For Down Sample
wire	[3:0]	Remain;
wire	[9:0]	Quotient;

wire	[15:0]	m4YCbCr;
wire	[15:0]	m5YCbCr;
wire	[8:0]	Tmp1,Tmp2;
wire	[7:0]	Tmp3,Tmp4;

wire            NTSC;
wire            PAL;
//=============================================================================
// Structural coding
//=============================================================================


//	All inout port turn to tri-state 
assign	AUD_XCK=AUD_CTRL_CLK;


assign	AUD_ADCLRCK	=	AUD_DACLRCK;
assign	GPIO_A	=	36'hzzzzzzzzz;
assign	GPIO_B	=	36'hzzzzzzzzz;

//	Turn On TV Decoder
assign	TD_RESET_N	=	1'b1;

assign	AUD_XCK	=	AUD_CTRL_CLK;

assign	LED	=	VGA_Y;




// added Score reg

//	7 segment LUT 
SEG7_LUT_6 			u0	(	.oSEG0(HEX0),
							.oSEG1(HEX1),
							.oSEG2(HEX2),
							.oSEG3(HEX3),
							.oSEG4(HEX4),
							.oSEG5(HEX5),
							.iDIG(HandState));
							
//	TV Decoder Stable Check
TD_Detect			u2	(	.oTD_Stable(TD_Stable),
							.oNTSC(NTSC),
							.oPAL(PAL),
							.iTD_VS(TD_VS),
							.iTD_HS(TD_HS),
							.iRST_N(KEY[0])	);

//	Reset Delay Timer
Reset_Delay			u3	(	.iCLK(CLOCK_50),
							.iRST(TD_Stable),
							.oRST_0(DLY0),
							.oRST_1(DLY1),
							.oRST_2(DLY2));

//	ITU-R 656 to YUV 4:2:2
ITU_656_Decoder		u4	(	//	TV Decoder Input
							.iTD_DATA(TD_DATA),
							//	Position Output
							.oTV_X(TV_X),
							//	YUV 4:2:2 Output
							.oYCbCr(YCbCr),
							.oDVAL(TV_DVAL),
							//	Control Signals
							.iSwap_CbCr(Quotient[0]),
							.iSkip(Remain==4'h0),
							.iRST_N(DLY1),
							.iCLK_27(TD_CLK27)	);

//	For Down Sample 720 to 640
DIV 				u5	(	.aclr(!DLY0),	
							.clock(TD_CLK27),
							.denom(4'h9),
							.numer(TV_X),
							.quotient(Quotient),
							.remain(Remain));

wire WR1_FULL;							
//	SDRAM frame buffer
Sdram_Control_4Port	u6	(	//	HOST Side
						   .REF_CLK(TD_CLK27),
							.CLK_18(AUD_CTRL_CLK),
							//Replacing DLY0 with 1'b1
						   .RESET_N(DLY0),
							//	FIFO Write Side 1
						   .WR1_DATA(YCbCr),
							.WR1(TV_DVAL),
							.WR1_FULL(WR1_FULL),
							.WR1_ADDR(0),
							.WR1_MAX_ADDR(NTSC ? 640*507 : 640*576),		//	525-18
							.WR1_LENGTH(9'h80),
							.WR1_LOAD(!DLY0),
							.WR1_CLK(TD_CLK27),
							//	FIFO Read Side 1
						   .RD1_DATA(m1YCbCr),
				        	.RD1(m1VGA_Read),
				        	.RD1_ADDR(NTSC ? 640*13 : 640*22),			//	Read odd field and bypess blanking
							.RD1_MAX_ADDR(NTSC ? 640*253 : 640*262),
							.RD1_LENGTH(9'h80),
				        	.RD1_LOAD(!DLY0),
							.RD1_CLK(TD_CLK27),
							//	FIFO Read Side 2
						    .RD2_DATA(m2YCbCr),
				        	.RD2(m2VGA_Read),
				        	.RD2_ADDR(NTSC ? 640*267 : 640*310),			//	Read even field and bypess blanking
							.RD2_MAX_ADDR(NTSC ? 640*507 : 640*550),
							.RD2_LENGTH(9'h80),
				        	.RD2_LOAD(!DLY0),
							.RD2_CLK(TD_CLK27),
							//	SDRAM Side
						   .SA(DRAM_ADDR),
						   .BA(DRAM_BA),
						   .CS_N(DRAM_CS_N),
						   .CKE(DRAM_CKE),
						   .RAS_N(DRAM_RAS_N),
				         .CAS_N(DRAM_CAS_N),
				         .WE_N(DRAM_WE_N),
						   .DQ(DRAM_DQ),
				         .DQM({DRAM_UDQM,DRAM_LDQM}),
							.SDR_CLK(DRAM_CLK)	);

//	YUV 4:2:2 to YUV 4:4:4
YUV422_to_444		u7	(	//	YUV 4:2:2 Input
							.iYCbCr(mYCbCr),
							//	YUV	4:4:4 Output
							.oY(mY),
							.oCb(mCb),
							.oCr(mCr),
							//	Control Signals
							.iX(VGA_X-160),
							.iCLK(TD_CLK27),
							.iRST_N(DLY0));

//	YCbCr 8-bit to RGB-10 bit 
YCbCr2RGB 			u8	(	//	Output Side
							.Red(mRed),
							.Green(mGreen),
							.Blue(mBlue),
							.oDVAL(mDVAL),
							//	Input Side
							
							.iY(BeforeRGB_Y),
							.iCb(BeforeRGB_Cb),
							.iCr(BeforeRGB_Cr),
							
							.iDVAL(VGA_Read),
							//	Control Signal
							.iRESET(!DLY2),
							.iCLK(TD_CLK27));
							
Mirror_Col u100  
	(  //  Input Side
		.iCCD_R       (mRed_0),
		.iCCD_G       (mGreen_0),
		.iCCD_B       (mBlue_0),
		.iCCD_DVAL    (mDVAL),
		.iCCD_PIXCLK  (VGA_CLK), //(TD_CLK),
		.iRST_N       (DLY2),
		//  Output Side
		.oCCD_R       (Red),
		.oCCD_G       (Green),
		.oCCD_B       (Blue)//,
    //.oCCD_DVAL(TV_DVAL));
	);

wire  [9:0]  mRed_0;
wire  [9:0]  mGreen_0;
wire  [9:0]  mBlue_0;


wire [9:0] VGA_Red;
wire [9:0] VGA_Green;
wire [9:0] VGA_Blue;

assign VGA_R = VGA_Red[9:2];
assign VGA_G = VGA_Green[9:2];
assign VGA_B = VGA_Blue[9:2];

VGA_Ctrl			u9	(	//	Host Side
							.iRed(mVGA_R),
							.iGreen(mVGA_G),
							.iBlue(mVGA_B),
							.oCurrent_X(VGA_X),
							.oCurrent_Y(VGA_Y),
							.oRequest(VGA_Read),
							//	VGA Side made changes as compared to previous design where we have VGA_R
//							.oVGA_R(mRed ),
//							.oVGA_G(mGreen ),
//							.oVGA_B(mBlue ),
                     .oVGA_R(VGA_Red ),
                     .oVGA_G(VGA_Green ),
                     .oVGA_B(VGA_Blue ),

							.oVGA_HS(VGA_HS),
							.oVGA_VS(VGA_VS),
							.oVGA_SYNC(VGA_SYNC_N),
							.oVGA_BLANK(VGA_BLANK_N),
							.oVGA_CLOCK(VGA_CLK),
							//	Control Signal
							.iCLK(TD_CLK27),
							.iRST_N(DLY2)	);

wire [9:0]  mVGA_R;
wire [9:0]  mVGA_G;
wire [9:0]  mVGA_B;
wire [9:0]  Red, Green, Blue;

assign  mVGA_R = Red;
assign  mVGA_G = Green;
assign  mVGA_B = Blue;
//  For ITU-R 656 Decoder

//  For VGA Controller

wire  [7:0]  mY,BeforeRGB_Y;
wire  [7:0]  mCb,BeforeRGB_Cb;
wire  [7:0]  mCr,BeforeRGB_Cr;
//  For field select

assign  m1VGA_Read=VGA_Y[0]?1'b0:VGA_Read;
assign  m2VGA_Read=VGA_Y[0]?VGA_Read:1'b0;

assign  mYCbCr_d=!VGA_Y[0]?m1YCbCr:m2YCbCr;
assign  mYCbCr=m5YCbCr;
wire 	    mDVAL;
reg  [7:0]	MiddleCr,MiddleCb;
reg  [4:0]	VGA_Counter;
reg  [15:0]	Skin_Binary_Temp;
reg  [3:0] 	Skin_Counter;
reg  [2:0] 	Frame_Counter;
wire   Hand_Cursor;
assign Hand_Cursor=((VGA_Y[8:2]==Hand_Y_Avg)&&(VGA_X[9:2]+2'd8>=Hand_X_Avg)&&(VGA_X[9:2]<=Hand_X_Avg+2'd8));
wire   skinFlg;
wire   Green;
wire   White;

assign LEDR[0]= IsSkin;


assign skinFlg= (mCb>=8'd80&&mCb<=8'd120)&&(mCr>=8'd131&&mCr<=8'd175);

wire [10:0] Hand_X;
wire [10:0] Hand_Y;
assign Hand_X={1'b0,Hand_X_Avg,2'b0};
assign Hand_Y={1'b0,Hand_Y_Avg,2'b0};
reg [7:0] Hand_XP;
wire[7:0] Hand_X_Avg;	
reg [6:0] Hand_YP;
wire[6:0] Hand_Y_Avg;
reg [7:0] LEFT_X,RIGHT_X;
reg [6:0] TOP_Y,BOT_Y;
reg [7:0] TEMP_X;
reg [6:0] TEMP_Y;
reg [2:0] HandState;
reg NewFrame,ContinueFlag;


parameter X_INIT=8'd320;
parameter Y_INIT=7'd240;

always@(posedge TD_CLK27)
begin
	if(SW[0])begin
		Hand_XP<=X_INIT;LEFT_X<=X_INIT;RIGHT_X<=X_INIT;
		Hand_YP<=Y_INIT;TOP_Y<=Y_INIT;BOT_Y<=Y_INIT;
		NewFrame<=1'b0;Frame_Counter<=3'b0;ContinueFlag<=1'b0;end
	else if(~VGA_VS|~VGA_HS)begin
		case (HandState)
			3'd0:begin if(NewFrame)begin
					HandState<=3'd1; 
					we<=1'b1;
					addr_reg<={Hand_XP,Hand_YP};
					NewFrame<=1'b0;
					ContinueFlag<=1'b0; end
			    else HandState<=3'd0;	
			end
			3'd1:begin if(SRAM_DQ[7]==1'b1)begin
					HandState<=2; we<=1'b1;
					addr_reg<={Hand_XP,Hand_YP};
					TEMP_X<=Hand_XP;
					TEMP_Y<=Hand_YP; end
				else begin we<=1'b1;ContinueFlag<=1'b0;HandState<=0; end
			end
			3'd2:begin if(SRAM_DQ[7]==1'b1&&TEMP_Y>=7'd2)begin
					we<=1'b1;
					addr_reg<={TEMP_X,TEMP_Y};
					TEMP_Y<=TEMP_Y-1'b1;
					ContinueFlag<=1'b0;
					HandState<=3'd2;end
				else if(ContinueFlag==1'b0)begin
					we<=1'b1;
					addr_reg<={TEMP_X,TEMP_Y};
					TEMP_Y<=TEMP_Y-1'b1;
					ContinueFlag<=1'b1;
					HandState<=3'd2; end
				else begin
					TOP_Y<=TEMP_Y;
					we<=1'b1;
					addr_reg<={Hand_XP,Hand_YP};
					TEMP_X<=Hand_XP;
					TEMP_Y<=Hand_YP;
					ContinueFlag<=1'b0;	
					HandState<=3'd3;end
			end
			3'd3:begin if(SRAM_DQ[7]==1'b1&&TEMP_Y<=7'd115)begin
					we<=1'b1;
					addr_reg<={TEMP_X,TEMP_Y};
					TEMP_Y<=TEMP_Y + 1'b1;
					ContinueFlag<=1'b0;
					HandState<=3'd3; end
				else if(ContinueFlag==1'b0) begin
					we<=1'b1;
					addr_reg<={TEMP_X,TEMP_Y};
					TEMP_Y<=TEMP_Y+1'b1;
					ContinueFlag<=1'b1;
					HandState<=3'd3; end
				else begin
					BOT_Y<=TEMP_Y;
					we<=1'b1;
					addr_reg<={Hand_XP,Hand_YP};
					TEMP_X<=Hand_XP;
					TEMP_Y<=Hand_YP;
					ContinueFlag<=1'b0;	
					HandState<=3'd4; end
			end
			3'd4: begin if(SRAM_DQ[7]==1'b1)begin
					we<=1'b1;
					addr_reg<={TEMP_X,TEMP_Y};
					TEMP_X<=TEMP_X+1'b1;
					ContinueFlag<=1'b0;
					HandState<=3'd4; end
				else if(ContinueFlag==1'b0)begin
					we<=1'b1;
					addr_reg<={TEMP_X,TEMP_Y};
					TEMP_X<=TEMP_X+1'b1;
					ContinueFlag<=1'b1;
					HandState<=3'd4;end
				else begin
					LEFT_X<=TEMP_X;
					we<=1'b1;
					addr_reg<={Hand_XP,Hand_YP};
					TEMP_X<=Hand_XP;
					TEMP_Y<=Hand_YP;
					ContinueFlag<=1'b0;	
					HandState<=3'd5;end
			end
			3'd5: begin if(SRAM_DQ[7]==1'b1&&TEMP_X>=8'd4)begin
					we<=1'b1;
					addr_reg<={TEMP_X,TEMP_Y};
					TEMP_X<=TEMP_X-1'b1;
					ContinueFlag<=1'b0;
					HandState<=3'd5;end
				else if(ContinueFlag==1'b0) begin
					we<=1'b1;
					addr_reg<={TEMP_X,TEMP_Y};
					TEMP_X<=TEMP_X-1'b1;
					ContinueFlag<=1'b1;
					HandState<=3'd5;end
				else begin
					RIGHT_X<=TEMP_X;
					we<=1'b1;
					addr_reg<={Hand_XP,Hand_YP};
					TEMP_X<=Hand_XP;
					TEMP_Y<=Hand_YP;
					ContinueFlag<=1'b0;	
					HandState<=3'd6;end
			end
			3'd6:begin
				//---------------X LIMIT--------------
				if(((LEFT_X>>1)+(RIGHT_X>>1)+1'b1)<=8'd5) Hand_XP<=8'd5;
				else if(((LEFT_X>>1)+(RIGHT_X>>1)+1'b1)>=8'd155) Hand_XP<=8'd155;
				else Hand_XP<=(LEFT_X>>1)+(RIGHT_X>>1)+1'b1;
				//---------------Y LIMIT--------------
				if(((TOP_Y>>1)+(BOT_Y>>1)+1'b1)<=7'd3) Hand_YP<=7'd3;
				else if(((TOP_Y>>1)+(BOT_Y>>1)+1'b1)>=7'd113) Hand_YP<=7'd113;					
				else Hand_YP<=(TOP_Y>>1)+(BOT_Y>>1)+1'b1;
				HandState<=3'd0; we<=1'b1;
				ContinueFlag<=1'b0;	
			end
		endcase
	end
end

assign BeforeRGB_Y =(score_board_0||score_board_1||E1||C||E2||Five||Seven||Six||Zero)?8'd175 :(Hand_Cursor)?8'd210:mY;
assign BeforeRGB_Cb=(score_board_0||score_board_1||E1||C||E2||Five||Seven||Six||Zero)?8'd36 :(Hand_Cursor)?8'd16:mCb;
assign BeforeRGB_Cr=(score_board_0||score_board_1||E1||C||E2||Five||Seven||Six||Zero)?8'd90:(Hand_Cursor)?8'd146:mCr;

wire   score_board_0;
wire   score_board_1;
wire   score_board_2;
wire E1; 
wire C; 
wire E2;
wire Five;
wire Seven;
wire Six; 
wire Zero;
reg	   [11:0] Score_reg;
assign LED_GREEN[8:0]=x_speed;							
							

Score_Board u_sb(
		.VGA_X			(VGA_X),
		.VGA_Y			(VGA_Y),
		.Current_Score	(Score_reg),
		.Score_flag_0 	(score_board_0),
		.Score_flag_1 	(score_board_1),
		.Score_flag_2 	(score_board_2),
		.E1flg			 	(E1),
	   .Cflg			 	   (C),
		.E2flg			 	(E2),
		.FiveFlg			 	(Five),
		.SevenFlg			(Seven),
		.SixFlg			 	(Six),
		.ZeroFlg			 	(Zero)
	);
hand_avg u_2b(
		.clock				(TD_CLK27),
		.reset				(SW[7]),	
		.LHPosition_X		(Hand_XP),
		.LHPosition_Y		(Hand_YP),
		.LHPosition_X_Avg	(Hand_X_Avg),
		.LHPosition_Y_Avg	(Hand_Y_Avg)
	);
	
////// Flags //////
////// Alberto //////
reg 		flgAlbe;
reg 		touchAlbe;
reg 		caughtAlbe;
////// Shaan //////
reg 		flgShaan;
reg 		touchShaan;
reg 		caughtShaan;
////// Godly //////
reg 		flgGodly;
reg 		touchGodly;
reg 		caughtGodly;
////// Bruce //////
reg 		flgBruce;
reg 		touchBruce;
reg 		caughtBruce;

reg 		bomb_flag;
reg 		bomb_cut_flag;
/// Enable signals /////
reg			input_enable;
reg			Shaan_en;
reg			Bruce_en;
reg			Godly_en;

reg			input_enable_bomb;
reg			speed_clk;

reg  [25:0]	counter_offset;
/// Random Variables
reg	 [10:0]	randAlbe;
reg	 [10:0]	randShaan;
reg	 [10:0]	randBruce;
reg	 [10:0]	randGodly;
reg	 [10:0]	bomb_x_rand;

/// Variables used in game FSM 
///////// Alberto ///////////
reg  [2:0]	AlbeState;
localparam  initAlbe =3'b001;
localparam  processAlbe=3'b010;
localparam  drawAlbe =3'b011;
localparam  timeAlbe =3'b100;
///////// Shaan ///////////
reg  [2:0]	ShaanState;
localparam  initShaan =3'b001;
localparam  processShaan=3'b010;
localparam  drawShaan =3'b011;
localparam  timeShaan =3'b100;
///////// Bruce ///////////
reg  [2:0]	BruceState;
localparam  initBruce =3'b001;
localparam  processBruce=3'b010;
localparam  drawBruce =3'b011;
localparam  timeBruce =3'b100;
///////// Bruce ///////////
reg  [2:0]	GodlyState;
localparam  initGodly =3'b001;
localparam  processGodly=3'b010;
localparam  drawGodly =3'b011;
localparam  timeGodly =3'b100;
	

wire [25:0] counter_var;

assign counter_var = SW[9]?26'h100000:(SW[8]?26'h19BFCC: 26'h1FFFFF);



	wire [8:0] x_speed;
	wire signed [8:0] y_speed;
	
	wire [8:0] x_speedShaan;
	wire signed [8:0] y_speedShaan;
	
	wire [8:0] x_speedGodly;
	wire signed [8:0] y_speedGodly;
	
	wire [8:0] x_speedBruce;
	wire signed [8:0] y_speedBruce;
	

	
	wire	   x_direction;
	wire	   y_direction;	
	
	wire	   x_dirShaan;
	wire	   y_dirShaan;
	
	wire	   x_dirGodly;
	wire	   y_dirGodly;
	
	wire	   x_dirBruce;
	wire	   y_dirBruce;

	//wire	   rand_state_apple;
	wire [2:0] rand_speed_Albe;
	wire [2:0] rand_speed_Shaan;
	wire [2:0] rand_speed_Bruce;
	wire [2:0] rand_speed_Godly;
	
position_calc u21
	(
		.clock			(TD_CLK27),
		.x_speed		(x_speed),
		.x_direction	(x_direction),
		.y_speed		(y_speed),
		.y_direction	(y_direction),
		.x_init			({6'd0,rand_speed_Albe}),
		.y_init			(9'd21),
		.input_enable	(input_enable),
		.switch0       (SW[8]),
		.switch1       (SW[9])
	);
	//-------------Shaan---------------
	position_calc u22
	(
		.clock			(TD_CLK27),
		.x_speed		(x_speedShaan),
		.x_direction	(x_dirShaan),
		.y_speed		(y_speedShaan),
		.y_direction	(y_dirShaan),
		.x_init			({6'd0,rand_speed_Shaan}),
		.y_init			(9'd20),
		.input_enable	(Shaan_en),
		.switch0       (SW[8]),
		.switch1       (SW[9])
	);
	position_calc u23
	(
		.clock			(TD_CLK27),
		.x_speed		(x_speedBruce),
		.x_direction	(x_dirBruce),
		.y_speed		(y_speedBruce),
		.y_direction	(y_dirBruce),
		.x_init			({6'd0,rand_speed_Bruce}),
		.y_init			(9'd19),
		.input_enable	(Bruce_en),
		.switch0       (SW[8]),
		.switch1       (SW[9])
	);
	position_calc u24
	(
		.clock			(TD_CLK27),
		.x_speed		(x_speedGodly),
		.x_direction	(x_dirGodly),
		.y_speed		(y_speedGodly),
		.y_direction	(y_dirGodly),
		.x_init			({6'd0,rand_speed_Godly}),
		.y_init			(9'd18),
		.input_enable	(Godly_en),
		.switch0       (SW[8]),
		.switch1       (SW[9])
	);	

	wire [15:0] dataAlbe;
	reg  [11:0] addressAlbe;
   wire [15:0] caught_dataAlbe;
	reg  [11:0] caught_addressAlbe;
	
   wire [15:0] dataShaan;
	reg  [11:0] addressShaan;
	wire [15:0] caught_dataShaan;
	reg  [11:0] caught_addressShaan;
	
	wire [15:0] dataGodly;
	reg  [11:0]  addressGodly;
	wire [15:0] caught_dataGodly;
	reg  [11:0]  caught_addressGodly;
	
	wire [15:0] dataBruce;
	reg  [11:0] addressBruce;
   wire [15:0] caught_dataBruce;
	reg  [11:0] caught_addressBruce;
	
	Alberto f20
	(
		.address	(addressAlbe),
		.clock	(TD_CLK27),            
		.data		(16'h0),
		.wren		(1'b0),
		.q			(dataAlbe)
	);

	caughtAlbe_func f120
	(
		.address	(caught_addressAlbe),
		.clock	(TD_CLK27),
		.data		(16'h0),
		.wren		(1'b0),
		.q			(caught_dataAlbe)
	);

	Godly f21
	(
		.address	(addressGodly),
		.clock	(TD_CLK27),
		.data		(16'h0),
		.wren		(1'b0),
		.q			(dataGodly)
	);		

	caughtGodly_func f121
	(
		.address	(caught_addressGodly),
		.clock	(TD_CLK27),
		.data		(16'h0),
		.wren		(1'b0),
		.q			(caught_dataGodly)
	);	
;

	Shaan f22
	(
		.address	(addressShaan),
		.clock	(TD_CLK27),
		.data		(16'h0),
		.wren		(1'b0),
		.q			(dataShaan)
	);		

	caughtShaan_func f122
	(
		.address	(caught_addressShaan),
		.clock	(TD_CLK27),
		.data		(16'h0),
		.wren		(1'b0),
		.q			(caught_dataShaan)
	);	


	Bruce f23
	(
		.address	(addressBruce),
		.clock	(TD_CLK27),
		.data		(16'h0),
	 	.wren		(1'b0),
		.q  		(dataBruce)
	);	  


	
	caughtBruce_func f123
	(
		.address	(caught_addressBruce),
		.clock		(TD_CLK27),
		.data		(16'h0),
		.wren		(1'b0),
		.q			(caught_dataBruce)
	);
	

//	Line buffer, delay one line
Line_Buffer u10	(	.aclr(!DLY0),
					.clken(VGA_Read),
					.clock(TD_CLK27),
					.shiftin(mYCbCr_d),
					.shiftout(m3YCbCr));

Line_Buffer u11	(	.aclr(!DLY0),
					.clken(VGA_Read),
					.clock(TD_CLK27),
					.shiftin(m3YCbCr),
					.shiftout(m4YCbCr));


				

assign LED_RED[10:0] =gen_rand_Albe;
assign LED_RED[11]   =y_direction;
assign LED_RED[12]   =caughtAlbe;
assign LED_RED[15:13]=rand_speed_Albe;
assign LED_RED[17:16]=rand_num_trigger_0[1:0];

random_number u_trigger_0
(	
	.clock		(speed_clk),
	.rand_seed	(9'd50),
	.reset		(SW[7]),
	.rand_num	(rand_num_trigger_0)
);

random_number u_trigger_1
(	
	.clock		(speed_clk),
	.rand_seed	(9'd150),
	.reset		(SW[7]),
	.rand_num	(rand_num_trigger_1)
);
					

